from cmo.problems.cdtlz import *
from cmo.problems.cf import *
from cmo.problems.ctp import *
from cmo.problems.dascmop import *
from cmo.problems.dcdtlz import *
from cmo.problems.lircmop import *
from cmo.problems.mw import *
from cmo.problems.nctp import *
from cmo.problems.cre import *
from cmo.problems.rcm import *
from cmo.problems.classic import *
from cmo.problems.modact import *
from cmo.problems.doc import *
from cmo.problems.zxhcf import *
from cmo.problems.step import *

__all__ = ['get_problem', 'get_problem_list']

PROBLEMS = {
    'c1dtlz1': C1DTLZ1,
    'c1dtlz3': C1DTLZ3,
    'c2dtlz2': C2DTLZ2,
    'convexc2dtlz2': ConvexC2DTLZ2,
    'c3dtlz1': C3DTLZ1,
    'c3dtlz4': C3DTLZ4,
    'cf1': CF1,
    'cf2': CF2,
    'cf3': CF3,
    'cf4': CF4,
    'cf5': CF5,
    'cf6': CF6,
    'cf7': CF7,
    'cf8': CF8,
    'cf9': CF9,
    'cf10': CF10,
    'ctp1': CTP1,
    'ctp2': CTP2,
    'ctp3': CTP3,
    'ctp4': CTP4,
    'ctp5': CTP5,
    'ctp6': CTP6,
    'ctp7': CTP7,
    'ctp8': CTP8,
    'cre21': CRE21,
    'cre22': CRE22,
    'cre23': CRE23,
    'cre24': CRE24,
    'cre25': CRE25,
    'cre31': CRE31,
    'cre32': CRE32,
    'dascmop1': DASCMOP1,
    'dascmop2': DASCMOP2,
    'dascmop3': DASCMOP3,
    'dascmop4': DASCMOP4,
    'dascmop5': DASCMOP5,
    'dascmop6': DASCMOP6,
    'dascmop7': DASCMOP7,
    'dascmop8': DASCMOP8,
    'dascmop9': DASCMOP9,
    'dc1dtlz1': DC1DTLZ1,
    'dc1dtlz3': DC1DTLZ3,
    'dc2dtlz1': DC2DTLZ1,
    'dc2dtlz3': DC2DTLZ3,
    'dc3dtlz1': DC3DTLZ1,
    'dc3dtlz3': DC3DTLZ3,
    'doc1': DOC1,
    'doc2': DOC2,
    'doc3': DOC3,
    'doc5': DOC5,
    'doc6': DOC6,
    'doc7': DOC7,
    'lircmop1': LIRCMOP1,
    'lircmop2': LIRCMOP2,
    'lircmop3': LIRCMOP3,
    'lircmop4': LIRCMOP4,
    'lircmop5': LIRCMOP5,
    'lircmop6': LIRCMOP6,
    'lircmop7': LIRCMOP7,
    'lircmop8': LIRCMOP8,
    'lircmop9': LIRCMOP9,
    'lircmop10': LIRCMOP10,
    'lircmop11': LIRCMOP11,
    'lircmop12': LIRCMOP12,
    'lircmop13': LIRCMOP13,
    'lircmop14': LIRCMOP14,
    'mw1': MW1,
    'mw2': MW2,
    'mw3': MW3,
    'mw4': MW4,
    'mw5': MW5,
    'mw6': MW6,
    'mw7': MW7,
    'mw8': MW8,
    'mw9': MW9,
    'mw10': MW10,
    'mw11': MW11,
    'mw12': MW12,
    'mw13': MW13,
    'mw14': MW14,
    'nctp1': NCTP1,
    'nctp2': NCTP2,
    'nctp3': NCTP3,
    'nctp4': NCTP4,
    'nctp5': NCTP5,
    'nctp6': NCTP6,
    'nctp7': NCTP7,
    'nctp8': NCTP8,
    'nctp9': NCTP9,
    'nctp10': NCTP10,
    'nctp11': NCTP11,
    'nctp12': NCTP12,
    'nctp13': NCTP13,
    'nctp14': NCTP14,
    'nctp15': NCTP15,
    'nctp16': NCTP16,
    'nctp17': NCTP17,
    'nctp18': NCTP18,
    'rcm2': RCM2,
    'rcm3': RCM3,
    'rcm4': RCM4,
    'rcm5': RCM5,
    'rcm7': RCM7,
    'rcm8': RCM8,
    'rcm10': RCM10,
    'rcm12': RCM12,
    'rcm14': RCM14,
    'rcm16': RCM16,
    'rcm18': RCM18,
    'rcm21': RCM21,
    'rcm27': RCM27,
    'step1': STEP1,
    'step2': STEP2,
    'step3': STEP3,
    'step4': STEP4,
    'step5': STEP5,
    'step6': STEP6,
    'step7': STEP7,
    'step8': STEP8,
    'step9': STEP9,
    'step10': STEP10,
    'step11': STEP11,
    'step12': STEP12,
    'step13': STEP13,
    'step14': STEP14,
    'step15': STEP15,
    'step16': STEP16,
    'step17': STEP17,
    'step18': STEP18,
    'step19': STEP19,
    'step20': STEP20,
    'step21': STEP21,
    'step22': STEP22,
    'step23': STEP23,
    'step24': STEP24,
    'step25': STEP25,
    'step26': STEP26,
    'step27': STEP27,
    'step28': STEP28,
    'step29': STEP29,
    'step30': STEP30,
    'bnh': BNH,
    'tnk': TNK,
    'srn': SRN,
    'osy': OSY,
    'wb': WB,
    'zxhcf1': ZXHCF1,
    'zxhcf2': ZXHCF2,
    'zxhcf3': ZXHCF3,
    'zxhcf4': ZXHCF4,
    'zxhcf5': ZXHCF5,
    'zxhcf6': ZXHCF6,
    'zxhcf7': ZXHCF7,
    'zxhcf8': ZXHCF8,
    'zxhcf9': ZXHCF9,
    'zxhcf10': ZXHCF10,
    'zxhcf11': ZXHCF11,
    'zxhcf12': ZXHCF12,
    'zxhcf13': ZXHCF13,
    'zxhcf14': ZXHCF14,
    'zxhcf15': ZXHCF15,
    'zxhcf16': ZXHCF16
}

# Problems not included in PROBLEMS are noted with a comment
ALL_PROBLEMS = {
    'c1dtlz1': C1DTLZ1,
    'c1dtlz3': C1DTLZ3,
    'c2dtlz2': C2DTLZ2,
    'convexc2dtlz2': ConvexC2DTLZ2,
    'c3dtlz1': C3DTLZ1,
    'c3dtlz4': C3DTLZ4,
    'cf1': CF1,
    'cf2': CF2,
    'cf3': CF3,
    'cf4': CF4,
    'cf5': CF5,
    'cf6': CF6,
    'cf7': CF7,
    'cf8': CF8,
    'cf9': CF9,
    'cf10': CF10,
    'cs1': CS1, # MODACT
    'cs2': CS2, # MODACT
    'cs3': CS3, # MODACT
    'cs4': CS4, # MODACT
    'ct1': CT1, # MODACT
    'ct2': CT2, # MODACT
    'ct3': CT3, # MODACT
    'ct4': CT4, # MODACT
    'cts1': CTS1, # MODACT
    'cts2': CTS2, # MODACT
    'cts3': CTS3, # MODACT
    'cts4': CTS4, # MODACT
    'ctse1': CTSE1, # MODACT
    'ctse2': CTSE2, # MODACT
    'ctse3': CTSE3, # MODACT
    'ctse4': CTSE4, # MODACT
    'ctsei1': CTSEI1, # MODACT
    'ctsei2': CTSEI2, # MODACT
    'ctsei3': CTSEI3, # MODACT
    'ctsei4': CTSEI4, # MODACT
    'ctp1': CTP1,
    'ctp2': CTP2,
    'ctp3': CTP3,
    'ctp4': CTP4,
    'ctp5': CTP5,
    'ctp6': CTP6,
    'ctp7': CTP7,
    'ctp8': CTP8,
    'cre21': CRE21,
    'cre22': CRE22,
    'cre23': CRE23,
    'cre24': CRE24,
    'cre25': CRE25,
    'cre31': CRE31,
    'cre32': CRE32,
    'cre51': CRE51,  # 5D
    'dascmop1': DASCMOP1,
    'dascmop2': DASCMOP2,
    'dascmop3': DASCMOP3,
    'dascmop4': DASCMOP4,
    'dascmop5': DASCMOP5,
    'dascmop6': DASCMOP6,
    'dascmop7': DASCMOP7,
    'dascmop8': DASCMOP8,
    'dascmop9': DASCMOP9,
    'dc1dtlz1': DC1DTLZ1,
    'dc1dtlz3': DC1DTLZ3,
    'dc2dtlz1': DC2DTLZ1,
    'dc2dtlz3': DC2DTLZ3,
    'dc3dtlz1': DC3DTLZ1,
    'dc3dtlz3': DC3DTLZ3,
    'doc1': DOC1,
    'doc2': DOC2,
    'doc3': DOC3,
    'doc4': DOC4,  # Issue with function evaluation
    'doc5': DOC5,
    'doc6': DOC6,
    'doc7': DOC7,
    'doc8': DOC8,  # Issue with Pareto front
    'doc9': DOC9,  # Issue with function evaluation
    'lircmop1': LIRCMOP1,
    'lircmop2': LIRCMOP2,
    'lircmop3': LIRCMOP3,
    'lircmop4': LIRCMOP4,
    'lircmop5': LIRCMOP5,
    'lircmop6': LIRCMOP6,
    'lircmop7': LIRCMOP7,
    'lircmop8': LIRCMOP8,
    'lircmop9': LIRCMOP9,
    'lircmop10': LIRCMOP10,
    'lircmop11': LIRCMOP11,
    'lircmop12': LIRCMOP12,
    'lircmop13': LIRCMOP13,
    'lircmop14': LIRCMOP14,
    'mw1': MW1,
    'mw2': MW2,
    'mw3': MW3,
    'mw4': MW4,
    'mw5': MW5,
    'mw6': MW6,
    'mw7': MW7,
    'mw8': MW8,
    'mw9': MW9,
    'mw10': MW10,
    'mw11': MW11,
    'mw12': MW12,
    'mw13': MW13,
    'mw14': MW14,
    'nctp1': NCTP1,
    'nctp2': NCTP2,
    'nctp3': NCTP3,
    'nctp4': NCTP4,
    'nctp5': NCTP5,
    'nctp6': NCTP6,
    'nctp7': NCTP7,
    'nctp8': NCTP8,
    'nctp9': NCTP9,
    'nctp10': NCTP10,
    'nctp11': NCTP11,
    'nctp12': NCTP12,
    'nctp13': NCTP13,
    'nctp14': NCTP14,
    'nctp15': NCTP15,
    'nctp16': NCTP16,
    'nctp17': NCTP17,
    'nctp18': NCTP18,
    'rcm1': RCM1, # Partially discrete
    'rcm2': RCM2,
    'rcm3': RCM3,
    'rcm4': RCM4,
    'rcm5': RCM5,
    'rcm7': RCM7,
    'rcm6': RCM6, # Partially discrete
    'rcm8': RCM8,
    'rcm10': RCM10,
    'rcm11': RCM11, # 5D
    'rcm12': RCM12,
    'rcm13': RCM13, # Partially discrete
    'rcm14': RCM14,
    'rcm15': RCM15, # Partially discrete
    'rcm16': RCM16,
    'rcm17': RCM17, # Issue with function evaluation
    'rcm18': RCM18,
    'rcm19': RCM19, # Partially discrete
    'rcm20': RCM20, # Issue with function evaluation
    'rcm21': RCM21,
    'rcm25': RCM25, # Partially discrete
    'rcm27': RCM27,
    'rcm29': RCM29, # Partially discrete
    'step1': STEP1,
    'step2': STEP2,
    'step3': STEP3,
    'step4': STEP4,
    'step5': STEP5,
    'step6': STEP6,
    'step7': STEP7,
    'step8': STEP8,
    'step9': STEP9,
    'step10': STEP10,
    'step11': STEP11,
    'step12': STEP12,
    'step13': STEP13,
    'step14': STEP14,
    'step15': STEP15,
    'step16': STEP16,
    'step17': STEP17,
    'step18': STEP18,
    'step19': STEP19,
    'step20': STEP20,
    'step21': STEP21,
    'step22': STEP22,
    'step23': STEP23,
    'step24': STEP24,
    'bnh': BNH,
    'tnk': TNK,
    'srn': SRN,
    'osy': OSY,
    'wb': WB,
    'zxhcf1': ZXHCF1,
    'zxhcf2': ZXHCF2,
    'zxhcf3': ZXHCF3,
    'zxhcf4': ZXHCF4,
    'zxhcf5': ZXHCF5,
    'zxhcf6': ZXHCF6,
    'zxhcf7': ZXHCF7,
    'zxhcf8': ZXHCF8,
    'zxhcf9': ZXHCF9,
    'zxhcf10': ZXHCF10,
    'zxhcf11': ZXHCF11,
    'zxhcf12': ZXHCF12,
    'zxhcf13': ZXHCF13,
    'zxhcf14': ZXHCF14,
    'zxhcf15': ZXHCF15,
    'zxhcf16': ZXHCF16,
}


def get_problem(name, *args, **kwargs):
    return PROBLEMS[name.lower()](*args, **kwargs)


def get_problem_list():
    return list(PROBLEMS.keys())


def get_all_problem_list():
    return list(ALL_PROBLEMS.keys())
